#include "FindPathThread.h"

using namespace std;

FindPathThread::FindPathThread(Queue* jobQueue) :
    jobQueue(jobQueue), matchObject(Match::instance()) {
  assert(jobQueue);
  wxThread::Create();
}

wxThread::ExitCode FindPathThread::Entry() {
  while (true) {
    ThreadJob job = jobQueue->Pop(); // This will block if the queue is empty
    string messageString = WordListUtil::toString(job.arg);
    string startWord = WordListUtil::firstWord(messageString);
    string endWord = WordListUtil::secondWord(messageString);
    vector<string> v = matchObject->shortestPathFromStartWordToEndWord(startWord, endWord);
    string result = "";
    BOOST_FOREACH(string s, v) {
      result += s + " ";
    }
    if (result != "")
      result.resize(result.size() - 1);
    jobQueue->Report(ThreadJob::ID_THREAD_PATH_FROM_START_END_WORDS, WordListUtil::toWxString(result), v.size());
  }
  return 0;
}
