#ifndef MATCH_H_
#define MATCH_H_

#include <cstdlib>
#include <string>
#include <iostream>
#include <vector>
#include <iterator>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <boost/foreach.hpp>
#include <boost/regex.hpp>
#include <boost/random.hpp>
#include <boost/unordered_set.hpp>
#include <boost/unordered_map.hpp>
#include "WordSearch.h"

class Match {
  private:
    Match();
    Match(const Match&);
    const Match& operator=(const Match&);
    boost::unordered_set<std::string> dictionary;
    static Match* matchInstance;

  public:
    static Match* instance();
    void setupDictionary(boost::unordered_set<std::string>&);
    const boost::unordered_set<std::string>& getDictionary();
    std::string getRandomWordFromDictionary();
    std::vector<std::string> keyVectorFromMap(const boost::unordered_map<std::string, std::vector<std::string> >&);
    std::vector<std::string> match(const boost::unordered_map<std::string, std::vector<std::string> >&, const boost::unordered_map<std::string, std::vector<std::string> >&);
    std::vector<std::string> shortestPathFromStartWordToEndWord(std::string, std::string);
    std::string trimWord(std::string);
    void convertToLowerCase(std::string&);
    std::string validateInput(std::string, std::string);
};

#endif
