#include "NeighborsFrame.h"
#include "wx/wx.h"

using namespace std;

class NeighborsApp : public wxApp {
    virtual bool OnInit();
};

DECLARE_EVENT_TYPE(wxEVT_THREAD, -1)
DEFINE_EVENT_TYPE(wxEVT_THREAD)

BEGIN_EVENT_TABLE(NeighborsFrame, wxFrame)
EVT_MENU(ID_NewGame, NeighborsFrame::OnNewGame)
EVT_MENU(ID_PathCalculator, NeighborsFrame::OnPathCalculator)
EVT_MENU(ID_About, NeighborsFrame::OnAbout)
EVT_MENU(ID_Help, NeighborsFrame::OnSimpleHelp)
EVT_MENU(ID_Quit, NeighborsFrame::OnQuit)
EVT_BUTTON(ID_Button, NeighborsFrame::OnButton)
EVT_BUTTON(ID_ButtonUndo, NeighborsFrame::OnButtonUndo)
EVT_BUTTON(ID_ButtonRedo, NeighborsFrame::OnButtonRedo)
EVT_COMBOBOX(ID_ComboBox, NeighborsFrame::OnComboBox)
EVT_KEY_UP(NeighborsFrame::OnKeyPress)
EVT_COMMAND(wxID_ANY, wxEVT_THREAD, NeighborsFrame::OnThread)
END_EVENT_TABLE()

IMPLEMENT_APP(NeighborsApp)

bool NeighborsApp::OnInit() {
  NeighborsFrame* frame = new NeighborsFrame(_("Word Neighbors"), wxDefaultPosition, wxSize(450, 500));
  frame->Show(true);
  SetTopWindow(frame);
  return true;
}
