#ifndef QUEUE_H_
#define QUEUE_H_

#include <map>
#include "ThreadJob.h"

DECLARE_EVENT_TYPE(wxEVT_THREAD, -1)

class Queue {
  public:
    enum Priority {
      HIGHEST, HIGHER, NORMAL, BELOW_NORMAL, LOW, IDLE
    };

    Queue(wxEvtHandler* parent);

    void AddJob(const ThreadJob& job, const Priority& priority = NORMAL);
    ThreadJob Pop();
    bool Empty();
    void Report(const ThreadJob::ThreadCommand& command, const wxString& sArg = wxEmptyString, int iArg = 0);
    size_t Stacksize();

  private:
    wxEvtHandler* parent;
    //multimap to reflect prioritization: values with lower keys come first, newer values with same key are appended
    std::multimap<Priority, ThreadJob> jobs;
    wxMutex mutexQueue;
    wxSemaphore queueCount;
};

#endif
