#include "WordListUtil.h"

using namespace std;

vector<string> WordListUtil::deleteLetter(const string& word) {
  vector<string> v;
  for (size_t i = 0; i < word.length(); ++i) {
    string temp = word;
    v.push_back(temp.erase(i, 1));
  }
  return v;
}

vector<string> WordListUtil::changeLetter(const string& word) {
  vector<string> v;
  for (size_t i = 0; i < word.length(); ++i) {
    for (char j = 'a'; j <= 'z'; ++j) {
      string temp = word;
      temp[i] = j;
      v.push_back(temp);
    }
  }
  return v;
}

vector<string> WordListUtil::addLetter(const string& word) {
  vector<string> v;
  for (size_t i = 0; i < word.length(); ++i) {
    for (char j = 'a'; j <= 'z'; ++j) {
      string temp = word;
      // insert letter before existing letter
      v.push_back(temp.insert(i, 1, j));
    }
  }

  for (char j = 'a'; j <= 'z'; ++j) {
    string temp = word;
    // add letter after last letter
    v.push_back(temp.append(1, j));
  }
  return v;
}

set<string> WordListUtil::nextWords(const string& word, const boost::unordered_set<string>& dictionary) {
  set<string> nextWordsSet;
  vector<string> v;
  vector<string> deleteLetterVector = deleteLetter(word);
  vector<string> changeLetterVector = changeLetter(word);
  vector<string> addLetterVector = addLetter(word);
  v.insert(v.end(), deleteLetterVector.begin(), deleteLetterVector.end());
  v.insert(v.end(), changeLetterVector.begin(), changeLetterVector.end());
  v.insert(v.end(), addLetterVector.begin(), addLetterVector.end());

  BOOST_FOREACH(string s, v) {
    if (dictionary.find(s) != dictionary.end() && s != word)
      nextWordsSet.insert(s);
  }
  return nextWordsSet;
}

wxString WordListUtil::toWxString(const string& s) {
  wxString word(s.c_str(), wxConvUTF8);
  return word;
}

string WordListUtil::toString(const wxString& w) {
  return string(w.mb_str());
}

string WordListUtil::firstWord(const string& s) {
  size_t pos = s.find(" ");
  return s.substr(0, pos);
}

string WordListUtil::secondWord(const string& s) {
  size_t pos = s.find(" ");
  return s.substr(pos + 1);
}
