#ifndef WORDLISTUTIL_H_
#define WORDLISTUTIL_H_

#include <string>
#include <vector>
#include <set>
#include <boost/unordered_set.hpp>
#include <boost/foreach.hpp>
#include "wx/wx.h"

class WordListUtil {
  private:
    static std::vector<std::string> deleteLetter(const std::string&);
    static std::vector<std::string> changeLetter(const std::string&);
    static std::vector<std::string> addLetter(const std::string&);

  public:
    static std::set<std::string> nextWords(const std::string&, const boost::unordered_set<std::string>&);
    static wxString toWxString(const std::string&);
    static std::string toString(const wxString&);
    static std::string firstWord(const std::string&);
    static std::string secondWord(const std::string&);
};

#endif
