#include "WordManager.h"

using namespace std;

WordManager::WordManager() :
    currentIndex(0) {
}

void WordManager::addWord(wxString word) {
  if (wordsSoFar.begin() + currentIndex != wordsSoFar.end())
    wordsSoFar.erase(wordsSoFar.begin() + currentIndex, wordsSoFar.end());
  wordsSoFar.push_back(word);
  ++currentIndex;
}

void WordManager::undo() {
  if (currentIndex > 1)
    --currentIndex;
}

void WordManager::redo() {
  if (currentIndex < wordsSoFar.size())
    ++currentIndex;
}

const vector<wxString>& WordManager::getWordList() {
  return wordsSoFar;
}

unsigned int WordManager::getCurrentIndex() {
  return currentIndex;
}

wxString WordManager::getCurrentWord() {
  return wordsSoFar.at(currentIndex - 1);
}

void WordManager::reset() {
  currentIndex = 0;
  wordsSoFar.empty();
}
