#ifndef WORDSEARCH_H
#define WORDSEARCH_H

#include <string>
#include <vector>
#include <boost/unordered_set.hpp>
#include <boost/unordered_map.hpp>

class WordSearch {
  private:
    const std::string startWord;
    const boost::unordered_set<std::string> dictionary;
    int numberWordsEverUsed;

    boost::unordered_map<std::string, std::vector<std::string> > wordsLast;
    boost::unordered_set<std::string> wordsEverUsed;
    boost::unordered_map<std::string, std::vector<std::string> > wordsCurrent;

    void processWord(const std::string&, boost::unordered_map<std::string, std::vector<std::string> >::iterator);
    void deleteLetter(boost::unordered_map<std::string, std::vector<std::string> >::iterator);
    void changeLetter(boost::unordered_map<std::string, std::vector<std::string> >::iterator);
    void addLetter(boost::unordered_map<std::string, std::vector<std::string> >::iterator);

  public:
    WordSearch(const std::string&, const boost::unordered_set<std::string>&);

    int getNumberWordsEverUsed();
    boost::unordered_map<std::string, std::vector<std::string> >& getWordsCurrent();
    void allPermutations();
};

inline int WordSearch::getNumberWordsEverUsed() {
  return numberWordsEverUsed;
}

inline boost::unordered_map<std::string, std::vector<std::string> >& WordSearch::getWordsCurrent() {
  return wordsCurrent;
}

#endif
